#include <FilePanel.h>
#include <Messenger.h>
#include <iostream.h>
#include <MenuItem.h>
#include <iostream.h>
#include <MenuBar.h>
#include <Message.h>
#include <String.h>
#include <Alert.h>
#include <Path.h>
#include <Menu.h>
#include <File.h>
#include <Beep.h>

#include "Santa/CLVEasyItem.h"
#include "Santa/CLVColumn.h"

#include "LinkSysWindow.h"
#include "TextFilter.h"
#include "Messages.h"
#include "SNMPHit.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
LinkSysWindow::LinkSysWindow()
 : BWindow(BRect( 30,30,570,230), "LinkSys Log Viewer", B_DOCUMENT_WINDOW, 0 )
{
  saveBox = new BFilePanel(B_SAVE_PANEL, NULL, NULL, 0, false, NULL, new TextFilter, true );
  saveBox->SetTarget( BMessenger(NULL, this) );
  Path = new BPath();

  BRect frame = Bounds();
  frame.top     = 20;
  frame.right  -= B_V_SCROLL_BAR_WIDTH;
  frame.bottom -= B_H_SCROLL_BAR_HEIGHT;

  BMenu *fileMenu = new BMenu( "Fájl" );
  Logging  =  new BMenuItem( "Enable Logging", new BMessage( ENABLE_LOGGING ) );
  Logging->SetTarget(this);
  fileMenu->AddItem( Logging );
  BMenuItem *save =  new BMenuItem( "Set Log File", new BMessage( SET_LOG_FILE ) );
  save->SetTarget(this);
  fileMenu->AddItem( save );

  BMenu *editMenu = new BMenu( "Szerkesztés" );
  BMenuItem *Clear =  new BMenuItem( "Clear", new BMessage( CLEAR ) );
  Clear->SetTarget(this);
  editMenu->AddItem( Clear );
  
  BMenu *IalertMenu = new BMenu( "Inbound Alert" );
  IActivate  =  new BMenuItem( "Activate", new BMessage( I_ALERT_ACTIVATE ) );
  IActivate->SetTarget(this);
  IalertMenu->AddItem( IActivate ); 
  ISound  =  new BMenuItem( "Beep", new BMessage( I_ALERT_SOUND ) );
  ISound->SetTarget(this);
  IalertMenu->AddItem( ISound ); 
  
  BMenu *OalertMenu = new BMenu( "Outbound Alert" );
  OActivate  =  new BMenuItem( "Activate", new BMessage( O_ALERT_ACTIVATE ) );
  OActivate->SetTarget(this);
  OalertMenu->AddItem( OActivate ); 
  OSound  =  new BMenuItem( "Beep", new BMessage( O_ALERT_SOUND ) );
  OSound->SetTarget(this);
  OalertMenu->AddItem( OSound ); 
  
  BMenu *helpMenu = new BMenu( "Súgó" );
  BMenuItem *about = new BMenuItem( "Névjegy", new BMessage( ABOUT ) );
  about->SetTarget(this);
  helpMenu->AddItem( about );

  BMenuBar *menuBar  = new BMenuBar( BRect( frame.left,0,frame.right,frame.top ), "Menu" );
  menuBar->AddItem( fileMenu );
  menuBar->AddItem( editMenu );
  menuBar->AddItem( IalertMenu );
  menuBar->AddItem( OalertMenu );
  menuBar->AddItem( helpMenu );
  AddChild(menuBar);

  listView = new ColumnListView(frame, &mainView, NULL, B_FOLLOW_ALL_SIDES,
		B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE,B_SINGLE_SELECTION_LIST, false, true, true, false, B_NO_BORDER );
  listView->AddColumn( new CLVColumn("Idő",         80, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH,                       20 ) );		
  listView->AddColumn( new CLVColumn("Be / Ki",     80, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH,                       20 ) );
  listView->AddColumn( new CLVColumn("Forrás",      120, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH | CLV_LOCK_WITH_RIGHT, 20 ) );
  listView->AddColumn( new CLVColumn("Port",         60, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH,                       20 ) );
  listView->AddColumn( new CLVColumn("Destination", 120, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH | CLV_LOCK_WITH_RIGHT, 20 ) );
  listView->AddColumn( new CLVColumn("Port",         60, CLV_HEADER_TRUNCATE | CLV_TELL_ITEMS_WIDTH,                       20 ) );
  
  AddChild( mainView );
  
  ini = new BIniFile();
  ini->Load("/boot/home/config/settings/LinkSysLogSettings");
  Path->SetTo( ini->ReadString("LinkSys Log Viewer 2.0","Log File" ) );
  if( Path->Path() ) Logging->SetMarked  ( ini->ReadBool("LinkSys Log Viewer 2.0","Enable Loging",      0 ) );
  IActivate->SetMarked ( ini->ReadBool("LinkSys Log Viewer 2.0","Enable Inbound Activation",  0 ) );
  OActivate->SetMarked ( ini->ReadBool("LinkSys Log Viewer 2.0","Enable Outbound Activation",  0 ) );
  ISound->SetMarked    ( ini->ReadBool("LinkSys Log Viewer 2.0","Enable Inbound Audio Alert", 0 ) );
  OSound->SetMarked    ( ini->ReadBool("LinkSys Log Viewer 2.0","Enable Outbound Audio Alert", 0 ) );
  Minimize(true);
  Show();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool LinkSysWindow::QuitRequested()
{
  Minimize(true);
  return false;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void LinkSysWindow::Quit()
{
  delete saveBox;
  delete ini;
  delete Path;
  BWindow::Quit();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void LinkSysWindow::SaveSettings()
{
  ini->Clear();
  ini->WriteBool("LinkSys Log Viewer 2.0","Enable Loging", Logging->IsMarked() );
  ini->WriteBool("LinkSys Log Viewer 2.0","Enable Inbound Activation", IActivate->IsMarked() ) ;
  ini->WriteBool("LinkSys Log Viewer 2.0","Enable Outbound Activation", OActivate->IsMarked() ) ;
  ini->WriteBool("LinkSys Log Viewer 2.0","Enable Inbound Audio Alert", ISound->IsMarked() ) ;
  ini->WriteBool("LinkSys Log Viewer 2.0","Enable Outbound Audio Alert", OSound->IsMarked() ) ;
  ini->WriteString("LinkSys Log Viewer 2.0","Log File", Path->Path() );
  ini->Store("/boot/home/config/settings/LinkSysLogSettings");
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void LinkSysWindow::MessageReceived(BMessage* message)
{
  switch( message->what )
  {
    case HIT:
    {
      float    max;
      float    val;
      int32    time;
      BString *string = new BString;
      
      message->FindString( "string", string );
      message->FindInt32(  "time",  &time);
      SNMPHit *hit = new SNMPHit( string, time, new BMessenger(NULL, this) );

      if( Logging->IsMarked() && Path->Path() ) {
        BFile *file = new BFile( Path->Path(), B_READ_WRITE | B_CREATE_FILE | B_OPEN_AT_END );
        BString log_entry = hit->String();
        file->Write( log_entry.String(), log_entry.Length()  );
        delete file;
      } 

      mainView->ScrollBar(B_VERTICAL)->GetRange(&val,&max);
      val = mainView->ScrollBar(B_VERTICAL)->Value();  
      listView->LockLooper();
      listView->AddItem( hit );
      if( max == val ) {
        mainView->ScrollBar(B_VERTICAL)->GetRange(&val,&max);
        mainView->LockLooper();
        mainView->ScrollBar(B_VERTICAL)->SetValue(max);
        mainView->UnlockLooper();
      }
      listView->UnlockLooper();
    }break;

    case CLEAR:
    {
      listView->LockLooper();
      listView->MakeEmpty();
      listView->UnlockLooper();  
    }break;

    case ENABLE_LOGGING:
    {
      Logging->SetMarked( ! Logging->IsMarked() ); 
      if( Logging->IsMarked() && ! Path->Path() ){ PostMessage( SET_LOG_FILE ); }
      SaveSettings();
    }break;

    case SET_LOG_FILE:
    {
      if( ! saveBox->IsShowing() ) saveBox->Show();
    }break;

    case I_ALERT_ACTIVATE:
    {
      IActivate->SetMarked( ! IActivate->IsMarked() ); 
      SaveSettings();
    }break;

    case I_ALERT_SOUND:
    {
      ISound->SetMarked( ! ISound->IsMarked() ); 
      SaveSettings();
    }break;
    
    case O_ALERT_ACTIVATE:
    {
      OActivate->SetMarked( ! OActivate->IsMarked() ); 
      SaveSettings();
    }break;

    case O_ALERT_SOUND:
    {
      OSound->SetMarked( ! OSound->IsMarked() ); 
      SaveSettings();
    }break;

    case ABOUT:
    {
      BAlert *Alert = new BAlert("About", "LinkSys Log Viewer v2.0\n\nProgram by Matthew Szatmary\n<slimscsi@comcast.net>\n\nIcon and PPC builds by Travis Chase\n<psichase@telusplanet.net>\n\nSpecial thanks to:\nBrian Tietz (for Sanata's gift bag)\n<briant@timelinevista.com>\nTyler Dauwalder (for BIniFile)\n<tylerdauwalder@users.sf.net>\n\n\nFor Updates to 'LinkSys Log Viewer' see http://www.bebits.com/app/2950", "Done");
      Alert->Go();
    }break;
    
    case INBOUND:
    {
      if( IActivate->IsMarked() )  Activate(1);
      if( ISound->IsMarked() )  beep();
      message->AddBool("inbound",1);
    }break;
    
    case OUTBOUND:
    {
      if( OActivate->IsMarked() )  Activate(1);
      if( OSound->IsMarked() )  beep();
      message->AddBool("inbound",0);
    }break;
    
    case B_CANCEL:
    {
      if( ! Path->Path() ) Logging->SetMarked(0);
    }break;
    
    case B_SAVE_REQUESTED:
    {
      entry_ref dir;
      BString name;
      message->FindRef("directory", &dir);
      message->FindString("name", &name);
      Path->SetTo( new BDirectory( &dir ), name.String() );
      SaveSettings();
    }break;
  }
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////